<?php
function mmcore($inputfile,$outputfile,$argumf,$arguml,$argums,$argummm,$flagf,$flagl,$flags,$flagd){
	include "prep.php";

	//Open file with digest
	if($flagd){
		if (!$out = fopen($outputfile, 'w')) {
			echo "Cannot open file ($argv[$plusout])";
			exit;
		}
	}
	
	//Open the list file
	if (!$outlist = fopen($outputfile."_pruned_and_representing.txt", 'w')) {
		echo "Cannot open file ($argv[$plusout])";
		exit;
	}
	if (fwrite($outlist, "Pruned\tRepresenting\n") === FALSE) {
		echo "Cannot write to file ($outlist)";
		exit;
	}
	$newick=file("$inputfile");
	$newicknum=count($newick);

	$line=preprocess($newick,$newicknum);
	//nodes
	$pattern="/((.*?):(.*?)[,\(\);])/i";
	$patternpar="/\)(.*?):.*/i";
	$c=0;
	$b=0;
	$vi=0;

	//here finds all
	preg_match_all($pattern,$line,$match);
	$matchnum=count($match[1]);

	//this is for identifying  )Bacteria:0.15 types
	$matchnum2=$matchnum-1;
	$patend="/\)$/i";
	for($h=0;$h<$matchnum2;$h++){
		if (preg_match($patend,$match[1][$h],$rand)){
			$plusone=$h+1;
			$match[1][$plusone]=")".$match[1][$plusone];
		}
	}
	//fill an array with 0,1,2,3... for use in the "for" following
	for($i=0;$i<$matchnum;$i++){
		$tobecut[$i]=$i;
	}
	//here divides nodes and leaves
	for($i=0;$i<$matchnum;$i++){
		$match[2][$i]=trim($match[2][$i],"()");
		if(preg_match($patternpar,$match[1][$i],$matchpar)){
			$matchpar[0]=trim($matchpar[0],"(,);");
			//here creates the array for finding all distances
			$minvi=$i-$vi;
			$minone=$minvi-1;
			$mintwo=$minvi-2;
			$pointarrayzero[$b]="$tobecut[$minvi]";
			$pointarrayone[$b]="$tobecut[$minone]";
			$pointarraytwo[$b]="$tobecut[$mintwo]";
			array_splice($tobecut, $mintwo, 2);
			$b++;
			$vi=$vi+2;
			$nodearray[$i]=$match[3][$i];
		}
		else{
			$match[1][$i]=trim($match[1][$i],"(,);");
			//here makes an array with the numbers of each leaf on the array key and the values of each key
			$leafarray[$i]=$match[3][$i];
			$c++;
		}
	}

	$pointarraynum=count($pointarrayzero);
	$leafarraynum=count($leafarray);
	$totalleaves=$leafarraynum;
	if(!$flagf){
		$argumf=$totalleaves;
	}
	if(!$flagl){
		$arguml=2;
	}
	if(!$flags){
		$argums=1;
	}
	if($arguml>$argumf){
		exit("Minimum number of leaves is bigger than Maximum number of leaves.");
	}
	//We check the special ocation when we have the total number of leaves
	$prstepflag=0;
	if($argumf>=$totalleaves){
		$prstepflag=1;	
	}
	///////////////////////////////////////////////////////////////////
	//Here are the repeats for leaves to cut///////////////////////////
	///////////////////////////////////////////////////////////////////
	$plusuni=0;
	//This is for steps when printing
	$repstep=$argumf;
	//The repeats until the algorithm ends
	$repeats=$totalleaves-$arguml;
	for($tri=0;$tri<$repeats;$tri++){
		//here we delete $unique;
		$unique=NULL;
		//sort arrays from lower to higher and their keys
		asort($leafarray);
		asort($nodearray);
		//here we get only the keys after asort in order to use them in for
		$nodekeys=array_keys($nodearray);
		$nodekeysnum=count($nodekeys);
		$leafkeys=array_keys($leafarray);
		$leafkeysnum=count($leafkeys);

		//HERE WE FIND CUPS////////////////////////////////
		//Pattern matching
		$patterncup="/(\(.*?\))/i";
		
		//CUPS
		//Match each one individually
		//new type for CUPS using point array
		//$time_start =  microtime(true);
		$c=0;
		$distadd=99999999;
		for($e=0;$e<$pointarraynum;$e++){
			if(array_key_exists($pointarrayone[$e],$leafarray) & array_key_exists($pointarraytwo[$e],$leafarray)){
				$cupsdist[$c]=abs($leafarray[$pointarrayone[$e]]+$leafarray[$pointarraytwo[$e]]);
				$cups[$c]="$pointarrayone[$e],$pointarraytwo[$e]";
				$cupsindi[$c]=$leafarray[$pointarrayone[$e]].",".$leafarray[$pointarraytwo[$e]];
				
				//Get the smallest adding distance between cups
				if($cupsdist[$c]<$distadd){
					$distadd=$cupsdist[$c];
					//for echo reasons only
					$forecho=$match[2][$pointarrayone[$e]].$match[2][$pointarraytwo[$e]]."\n";
					$cget=$c;
				}
				$c++;
			}
		}
		$lowercupdist=$distadd;

		/////////////////////////////////////////////////////////////////////////////////
		///// HERE WE FLIP THE VALUES WITH THE KEYS /////////////////////////////////////
		/////////////////////////////////////////////////////////////////////////////////
		$flipone=array_flip($pointarrayone);
		$fliptwo=array_flip($pointarraytwo);
		//here we get the leave-nodes to compare them with the CUPS
		$leafnomore=$leafkeysnum;
		for($i=0;$i<$leafkeysnum;$i++){
			//if itoj array exists
			$ai=$i+1;
			if($i<$leafnomore){
				for($j=$ai;$j<$leafnomore;$j++){
					if(!isset($uniquearray[$leafkeys[$i]][$leafkeys[$j]])){
						$addfinal=$nodearray[$nodekeys[0]]+$leafarray[$leafkeys[$i]]+$leafarray[$leafkeys[$j]];

						$unique="$leafkeys[$i],$leafkeys[$j]";

						$uniquearray[$leafkeys[$i]][$leafkeys[$j]]=$unique;
						//here searches the point array and creates the paths! searches from the unique array
						$expunique=explode(",",$unique);
						$tempadddist=0;
						$alpha=1;
						$closeone=1;
						$closetwo=1;
						while($alpha){
							if($closeone){
								if(isset($flipone[$expunique[0]])){
									$tempadddist+=$match[3][$expunique[0]];
									//get the value from fliped to which is the key for pointarrayzero
									$expunique[0]=$pointarrayzero[$flipone[$expunique[0]]];
									//echo "flipone one $expunique[0]\n";
								}
								elseif(isset($fliptwo[$expunique[0]])){
									$tempadddist+=$match[3][$expunique[0]];
									//get the value from fliped to which is the key for pointarrayzero
									$expunique[0]=$pointarrayzero[$fliptwo[$expunique[0]]];
								}
							}
							//
							if($closetwo){
								if(isset($flipone[$expunique[1]])){
									$tempadddist+=$match[3][$expunique[1]];
									$expunique[1]=$pointarrayzero[$flipone[$expunique[1]]];
								}
								elseif(isset($fliptwo[$expunique[1]])){
									$tempadddist+=$match[3][$expunique[1]];
									$expunique[1]=$pointarrayzero[$fliptwo[$expunique[1]]];
								}
							}
							//HERE we open or close the above ifs
							if(($expunique[1]>$expunique[0]) || (!isset($flipone[$expunique[1]]) & !isset($fliptwo[$expunique[1]]))){
								$closetwo=0;
								$closeone=1;
							}
							elseif(($expunique[0]>$expunique[1]) || (!isset($flipone[$expunique[0]]) & !isset($fliptwo[$expunique[0]]))){
								$closeone=0;
								$closetwo=1;
							}
							//end statement
							if($expunique[0]==$expunique[1]){
								$alpha=0;
							}
						}
						//here we change the cutof so it gets smaller and tighter on each iteration
						if($tempadddist<$distadd){
							$finaluniq=$unique;

							$distadd=$tempadddist;
							$geti=$i;
						}
						//here we create the array so it wont take it twice
						$tempadddistarray[$leafkeys[$i]][$leafkeys[$j]]=$tempadddist;
						if($addfinal>$distadd){
							$leafnomore=$j;
						}
					}
				}
				if(isset($tempadddistarray[$leafkeys[$i]])){
					if($tempadddistarray[$leafkeys[$i]]!=NULL){
						if(($mindist=min($tempadddistarray[$leafkeys[$i]]))<$distadd){
							$distadd=$mindist;
							$mindistkey=array_keys($tempadddistarray[$leafkeys[$i]],$mindist);
							$finaluniq=$uniquearray[$leafkeys[$i]][$mindistkey[0]];
							$echodo=explode(",",$finaluniq);
						}
					}
				}
			}
			else{
				break;
			}
		}

		if($distadd==$lowercupdist){
			$finaluniq=NULL;
		}
		if($finaluniq!=NULL){
			//here we will use the MATH FORMULA
			//here we also find the common node and the distance from it for both leaves
			$expgetleaves=explode(",",$finaluniq);
			$keepleaves[0]=$expgetleaves[0];
			$keepleaves[1]=$expgetleaves[1];

			$commonnodedistone=0;
			$commonnodeonecnt=0;
			$commonnodedisttwo=0;
			$commonnodetwocnt=0;
			$distunder=NULL;
			$alpha=1;
			$closeone=1;
			$closetwo=1;
			while($alpha){
				if($closeone){
					if(isset($flipone[$expgetleaves[0]])){
						//here we keep the final CN
						$cn[0]=$expgetleaves[0];
						$reversee[0]=$flipone[$expgetleaves[0]]-1;
						//this is the distance from common node
						$commonnodedistone+=$match[3][$expgetleaves[0]];
						$expgetleaves[0]=$pointarrayzero[$flipone[$expgetleaves[0]]];
						$commonnodeonecnt++;
					}
					elseif(isset($fliptwo[$expgetleaves[0]])){
						//here we keep the final CN
						$cn[0]=$expgetleaves[0];
						$reversee[0]=$fliptwo[$expgetleaves[0]]-1;
						//this is the distance from common node
						$commonnodedistone+=$match[3][$expgetleaves[0]];
						$expgetleaves[0]=$pointarrayzero[$fliptwo[$expgetleaves[0]]];
						$commonnodeonecnt++;
					}
				}
				//
				if($closetwo){
					if(isset($flipone[$expgetleaves[1]])){
						//here we keep the final CN
						$cn[1]=$expgetleaves[1];
						$reversee[1]=$flipone[$expgetleaves[1]]-1;
						//this is the distance from common node
						$commonnodedisttwo+=$match[3][$expgetleaves[1]];
						$expgetleaves[1]=$pointarrayzero[$flipone[$expgetleaves[1]]];
						$commonnodetwocnt++;
					}
					elseif(isset($fliptwo[$expgetleaves[1]])){
						//here we keep the final CN
						$cn[1]=$expgetleaves[1];
						$reversee[1]=$fliptwo[$expgetleaves[1]]-1;
						//this is the distance from common node
						$commonnodedisttwo+=$match[3][$expgetleaves[1]];
						$expgetleaves[1]=$pointarrayzero[$fliptwo[$expgetleaves[1]]];
						$commonnodetwocnt++;
					}
				}
				//HERE we open or close the above ifs
				if(($expgetleaves[1]>$expgetleaves[0]) || (!isset($flipone[$expgetleaves[1]]) & !isset($fliptwo[$expgetleaves[1]]))){
					$closetwo=0;
					$closeone=1;
				}
				elseif(($expgetleaves[0]>$expgetleaves[1]) || (!isset($flipone[$expgetleaves[0]]) & !isset($fliptwo[$expgetleaves[0]]))){
					$closeone=0;
					$closetwo=1;
				}
				//end statement
				if($expgetleaves[0]==$expgetleaves[1]){
					$alpha=0;
				}
			}
			//we need to get the total leaves above the common node and those under it
			$c=0;
			//we start with 2 because is the 2 we have already found
			$leavesunder=0;
			//REVERSE
			//Here is the reverse search for the leaves under the common node
			for($i=0;$i<2;$i++){
				$reversenode=NULL;
				$flagopen=0;
				//in this if we check if a cn[$i] is actually a leaf
				if(array_key_exists($cn[$i],$nodearray)){
					$reversenode=$cn[$i];
					$nodecount=0;
					for($e=$reversee[$i];$e>-1;$e--){
						if($pointarrayzero[$e]==$cn[$i]){
							$flagopen=1;
						}
						if($flagopen){
							//here finds the first node on search[0]
							//Here we will create 4 cases where it will chose one every time it meets the requirements
							if(array_key_exists($pointarrayone[$e],$leafarray) & array_key_exists($pointarraytwo[$e],$nodearray)){
								$reversenode=$pointarraytwo[$e];
								$leavesunder++;
								//This is to prevent it from taking the leaves we are looking to cut
								if($pointarrayone[$e]!=$keepleaves[0] & $pointarrayone[$e]!=$keepleaves[1]){
									$distunder[$c]=$pointarrayone[$e];
									$c++;
								}
							}
							else if(array_key_exists($pointarraytwo[$e],$leafarray) & array_key_exists($pointarrayone[$e],$nodearray)){
								$reversenode=$pointarrayone[$e];
								$leavesunder++;
								//This is to prevent it from taking the leaves we are looking to cut
								if($pointarraytwo[$e]!=$keepleaves[0] & $pointarraytwo[$e]!=$keepleaves[1]){
									$distunder[$c]=$pointarraytwo[$e];
									$c++;
								}
							}
							else if(array_key_exists($pointarrayone[$e],$leafarray) & array_key_exists($pointarraytwo[$e],$leafarray)){
								$leavesunder++;
								//This is to prevent it from taking the leaves we are looking to cut
								if($pointarrayone[$e]!=$keepleaves[0] & $pointarrayone[$e]!=$keepleaves[1]){
									$distunder[$c]=$pointarrayone[$e];
									$c++;
								}
								$leavesunder++;
								//This is to prevent it from taking the leaves we are looking to cut
								if($pointarraytwo[$e]!=$keepleaves[0] & $pointarraytwo[$e]!=$keepleaves[1]){
									$distunder[$c]=$pointarraytwo[$e];
									$c++;
								}
								$nodecount--;
								if($nodecount<=0){
									break;
								}
							}
							else if(array_key_exists($pointarrayone[$e],$nodearray) & array_key_exists($pointarraytwo[$e],$nodearray)){
								//here we insert $search[2] first and then $search[1] because its the way array splice works
								if($nodecount==0){
									$nodecount+=2;
								}
								else{
									$nodecount+=1;
								}
							}
						}
					}
				}
				else{
					$leavesunder++;
				}
			}
			$distundernum=count($distunder);
			$leavesabove=$leafarraynum-$leavesunder;
			//here we find the distance from unique (leaves) and distunder
			$distinside=NULL;
			for($i=0;$i<2;$i++){
				for($j=0;$j<$distundernum;$j++){
					$distinside[$i][$j]=0;
					$tempkeepleaves=$keepleaves[$i];
					$tempdistunder=$distunder[$j];
						$alpha=1;
						$closeone=1;
						$closetwo=1;
						while($alpha){
							if($closeone){
								if(isset($flipone[$tempkeepleaves])){
									$distinside[$i][$j]+=$match[3][$tempkeepleaves];
									$tempkeepleaves=$pointarrayzero[$flipone[$tempkeepleaves]];
								}
								elseif(isset($fliptwo[$tempkeepleaves])){
									$distinside[$i][$j]+=$match[3][$tempkeepleaves];
									$tempkeepleaves=$pointarrayzero[$fliptwo[$tempkeepleaves]];
								}
							}
							if($closetwo){
								if(isset($flipone[$tempdistunder])){
									$distinside[$i][$j]+=$match[3][$tempdistunder];
									$tempdistunder=$pointarrayzero[$flipone[$tempdistunder]];
								}
								elseif(isset($fliptwo[$tempdistunder])){
									$distinside[$i][$j]+=$match[3][$tempdistunder];
									$tempdistunder=$pointarrayzero[$fliptwo[$tempdistunder]];
								}
							}
							//HERE we open or close the above ifs
							if(($tempdistunder>$tempkeepleaves) || (!isset($flipone[$tempdistunder]) & !isset($fliptwo[$tempdistunder]))){
								$closetwo=0;
								$closeone=1;
							}
							elseif(($tempkeepleaves>$tempdistunder) || (!isset($flipone[$tempkeepleaves]) & !isset($fliptwo[$tempkeepleaves]))){
								$closeone=0;
								$closetwo=1;
							}
							//end statement
							if($tempkeepleaves==$tempdistunder){
								$alpha=0;
							}
						}
				}
			}
			//$time_end =  microtime(true);
			//$time = $time_end - $time_start;

			//the number of inside leaves are the same for both leaves
			$distinsidenum=count($distinside[0]);
			
			//here is the math formula
			$formulaone=$commonnodedistone*$leavesabove;
			for($i=0;$i<$distinsidenum;$i++){
				$formulaone+=$distinside[0][$i];
			}
			$formulatwo=$commonnodedisttwo*$leavesabove;
			for($i=0;$i<$distinsidenum;$i++){
				$formulatwo+=$distinside[1][$i];
			}

			$dif=$formulaone-$formulatwo;
			
			//maxmin or maxmax
			
			if($argummm=="maxmin"){
				if($dif>0){
					$magic=$keepleaves[0];
					$leftfrommagic=$keepleaves[1];
				}
				else if ($dif<0){
					$magic=$keepleaves[1];
					$leftfrommagic=$keepleaves[0];		
				}
				else{
					if($commonnodeonecnt<$commonnodetwocnt){
						$magic=$keepleaves[1];
						$leftfrommagic=$keepleaves[0];
					}
					else{
						$magic=$keepleaves[0];
						$leftfrommagic=$keepleaves[1];
					}
				}
			}elseif($argummm=="maxmax"){
				if($dif>0){
                                        $magic=$keepleaves[1];
                                        $leftfrommagic=$keepleaves[0];
                                }
                                else if ($dif<0){
                                        $magic=$keepleaves[0];
                                        $leftfrommagic=$keepleaves[1];
                                }
                                else{
                                        if($commonnodeonecnt<$commonnodetwocnt){
                                                $magic=$keepleaves[0];
                                                $leftfrommagic=$keepleaves[1];
                                        }
                                        else{
                                                $magic=$keepleaves[1];
                                                $leftfrommagic=$keepleaves[0];
                                        }
                                }
			}
		}
		else{
			$cupindiexp=explode(",",$cupsindi[$cget]);
			$cupsexp=explode(",",$cups[$cget]);
			if($argummm=="maxmin"){
				if($cupindiexp[0]>$cupindiexp[1]){
					$magic=$cupsexp[0];
					$leftfrommagic=$cupsexp[1];
				}
				else{
					$magic=$cupsexp[1];
					$leftfrommagic=$cupsexp[0];
				}
			}elseif($argummm=="maxmax"){
				if($cupindiexp[0]>$cupindiexp[1]){
                                        $magic=$cupsexp[1];
                                        $leftfrommagic=$cupsexp[0];
                                }
                                else{
                                        $magic=$cupsexp[0];
                                        $leftfrommagic=$cupsexp[1];
                                }
			}
		}
		
		//Here we change arrays for repeats pointarray,leafarray,nodearray,match[3]

		$alpha=1;
		while($alpha){
			if(isset($flipone[$magic])){

				$newadd=$match[3][$pointarrayzero[$flipone[$magic]]]+$match[3][$pointarraytwo[$flipone[$magic]]];
				$old=$pointarrayzero[$flipone[$magic]];

				$change=$pointarraytwo[$flipone[$magic]];
				$newnodeonly=$match[3][$pointarrayzero[$flipone[$magic]]];
				array_splice($pointarrayzero, $flipone[$magic], 1);
				array_splice($pointarrayone, $flipone[$magic], 1);

				array_splice($pointarraytwo, $flipone[$magic], 1);

				$pointarraynum--;
				break;
			}
			else if(isset($fliptwo[$magic])){
				$newadd=$match[3][$pointarrayzero[$fliptwo[$magic]]]+$match[3][$pointarrayone[$fliptwo[$magic]]];
				$old=$pointarrayzero[$fliptwo[$magic]];

				$change=$pointarrayone[$fliptwo[$magic]];
				$newnodeonly=$match[3][$pointarrayzero[$fliptwo[$magic]]];
				array_splice($pointarrayzero, $fliptwo[$magic], 1);
				array_splice($pointarrayone, $fliptwo[$magic], 1);

				array_splice($pointarraytwo, $fliptwo[$magic], 1);

				$pointarraynum--;
				break;
			}
		}
		
		//Here we cant use index cos flipone and fliptwo change
		for($e=0;$e<$pointarraynum;$e++){
			if($pointarrayone[$e]==$old){
				$pointarrayone[$e]=$change;
				break;
			}
			elseif($pointarraytwo[$e]==$old){
				$pointarraytwo[$e]=$change;
				break;
			}
		}
		//now to delete leaf from leafarray 
		unset($leafarray[$magic]);
		//and here to replace the other leaf with the new one (leaf+node)
		if(array_key_exists($change,$leafarray)){
			$leafarray[$change]=$newadd;
		}
		$leafarraynum--;

		//now to delete node from nodearray 
		unset($nodearray[$old]);
		
		//and here to clear match[3]
		unset($match[3][$magic]);
		unset($match[3][$old]);
		$match[3][$change]=$newadd;

		if($uniquearray!=NULL){
			unset($uniquearray[$magic]);
			unset($tempadddistarray[$magic]);
			//for the rest
			foreach($uniquearray as $key => $value){
				if(isset($uniquearray[$key][$magic])){
					unset($uniquearray[$key][$magic]);
					unset($tempadddistarray[$key][$magic]);
				}
			}
		}
		$plusone=$tri+1;
		//PRINTING newick in every repeat
		//Here we make the newick THE FINAL RESULT
		if($prstepflag){
			$prstep=$totalleaves-$tri+1+abs($argumf-$totalleaves);
		}else{
			$prstep=$totalleaves-$tri;
		}
		if($prstep==$argumf+1 || $prstep==$repstep+1){
			$repstep=$repstep-$argums;
			$newick=NULL;
			$c=-1;
			
			//for single quotes, removes them if there is no violation
        		//does not removes or intruduces them if there is violation
        		$patternautakia="/^'|'$/i";
			
			for($e=0;$e<$pointarraynum;$e++){
					//for autakia
                        		if (strpos($match[2][$pointarraytwo[$e]], 'zibiiiiit82') !== FALSE) {
                                		if(!preg_match($patternautakia,$match[2][$pointarraytwo[$e]],$matchautakia)){
                                        		$match[2][$pointarraytwo[$e]]="'".$match[2][$pointarraytwo[$e]]."'";
                                		}
                        		}else if(preg_match($patternautakia,$match[2][$pointarraytwo[$e]],$matchautakia)){
                               			$match[2][$pointarraytwo[$e]]=trim($match[2][$pointarraytwo[$e]],"'");
                        		}
                        		//for autakia
                        		if (strpos($match[2][$pointarrayone[$e]], 'zibiiiiit82') !== FALSE) {
                                		if(!preg_match($patternautakia,$match[2][$pointarrayone[$e]],$matchautakia)){
                                        		$match[2][$pointarrayone[$e]]="'".$match[2][$pointarrayone[$e]]."'";
                                		}
                        		}else if(preg_match($patternautakia,$match[2][$pointarrayone[$e]],$matchautakia)){
                                		$match[2][$pointarrayone[$e]]=trim($match[2][$pointarrayone[$e]],"'");
                        		}
				if(array_key_exists($pointarrayone[$e],$leafarray) && array_key_exists($pointarraytwo[$e],$leafarray)){
					$c++;
					$newick[$c]="(".$match[2][$pointarraytwo[$e]].":".$match[3][$pointarraytwo[$e]].",".$match[2][$pointarrayone[$e]].":".$match[3][$pointarrayone[$e]]."):".$match[3][$pointarrayzero[$e]];
					$newickkey[$c]=$pointarrayzero[$e];
				}
				else if(array_key_exists($pointarrayone[$e],$leafarray)){
					$thecis=array_search($pointarraytwo[$e],$newickkey);
					$newick[$thecis]="(".$newick[$thecis].",".$match[2][$pointarrayone[$e]].":".$match[3][$pointarrayone[$e]]."):".$match[3][$pointarrayzero[$e]];
					$newickkey[$thecis]=$pointarrayzero[$e];
				}
				else if(array_key_exists($pointarraytwo[$e],$leafarray)){
					$thecis=array_search($pointarrayone[$e],$newickkey);
					$newick[$thecis]="(".$match[2][$pointarraytwo[$e]].":".$match[3][$pointarraytwo[$e]].",".$newick[$thecis]."):".$match[3][$pointarrayzero[$e]];
					$newickkey[$thecis]=$pointarrayzero[$e];
				}
				else{
					$inone=array_search($pointarrayone[$e],$newickkey);
					$intwo=array_search($pointarraytwo[$e],$newickkey);
					//intwo is always smaller
					$newick[$intwo]="(".$newick[$intwo].",".$newick[$inone]."):".$match[3][$pointarrayzero[$e]];
					unset($newick[$inone]);
					$newickkey[$intwo]=$pointarrayzero[$e];
					unset($newickkey[$inone]);
				}
			}
				//closing statement
			$new="(".$newick[0].");";

			if(!$flagd){
				if($prstepflag){
					$prminus=$prstep-2-abs($argumf-$totalleaves);
				}else{
					$prminus=$prstep-1;
				}
				if(!strncmp(strtoupper(PHP_OS),"WIN",3)) {
					$winexp=explode("\\",$outputfile);
//					if($winexp[1]==NULL){
					if(count($winexp)==1){
						$windotexp=explode(".",$outputfile);
//						if($windotexp[1]==NULL){
						if(count($windotexp)==1){
							$outname=$outputfile."_".$prminus;
						}
						else{
							$outname=$windotexp[0]."_".$prminus.".".$windotexp[1];
						}
					}
					else{
						$winexpnum=count($winexp);
						$winnum=$winexpnum-1;
						$windotexp=explode(".",$winexp[$winnum]);
						if($windotexp[1]==NULL){
							$outname=$winexp[$winnum]."_".$prminus;
						}
						else{
							$outname=$windotexp[0]."_".$prminus.".".$windotexp[1];
						}
						$winname=NULL;
						for($k=0;$k<$winnum;$k++){
							$winname.=$winexp[$k]."\\";
						}
						$outname=$winname.$outname;
					}
				}
				else {
					$linexp=explode("/",$outputfile);
//					if($linexp[1]==NULL){
					if(count($linexp)==1){
						$lindotexp=explode(".",$outputfile);
//						if($lindotexp[1]==NULL){
						if(count($lindotexp)==1){
							$outname=$outputfile."_".$prminus;
						}
						else{
							$outname=$lindotexp[0]."_".$prminus.".".$lindotexp[1];
						}
					}
					else{
						$linexpnum=count($linexp);
						$linnum=$linexpnum-1;
						$lindotexp=explode(".",$linexp[$linnum]);
						if($lindotexp[1]==NULL){
							$outname=$linexp[$winnum]."_".$prminus;
						}
						else{
							$outname=$lindotexp[0]."_".$prminus.".".$lindotexp[1];
						}
						$linname=NULL;
						for($k=0;$k<$linexpnum;$k++){
							$linname.=$linexp."\\";
						}
						$outname=$linname.$outname;
					}
				}
				if (!$out = fopen($outname, 'w')) {
					echo "Cannot open file ($outname)";
					exit;
				}
				//replace zibiiiiit82,83
				$new=str_replace("zibiiiiit82","(",$new);
				$new=str_replace("zibiiiiit83",")",$new);
				if (fwrite($out, "$new\n\n") === FALSE) {
					echo "Cannot write to file ($out)";
					exit;
				}	
			}
			else{
				//replace zibiiiiit82,83
                                $new=str_replace("zibiiiiit82","(",$new);
                                $new=str_replace("zibiiiiit83",")",$new);
				if (fwrite($out, "$new\n\n") === FALSE) {
					echo "Cannot write to file ($outputfile)";
					exit;
				}	
			}
			$new=NULL;
			//write the pruned and representing
			//replace zibiiiiit82,83
                        $match[2][$magic]=str_replace("zibiiiiit82","(",$match[2][$magic]);
                        $match[2][$magic]=str_replace("zibiiiiit83",")",$match[2][$magic]);
			//replace zibiiiiit82,83
                        $match[2][$leftfrommagic]=str_replace("zibiiiiit82","(",$match[2][$leftfrommagic]);
                        $match[2][$leftfrommagic]=str_replace("zibiiiiit83",")",$match[2][$leftfrommagic]);
			if (fwrite($outlist, $match[2][$magic]."\t".$match[2][$leftfrommagic]."\n") === FALSE) {
				echo "Cannot write to file ($outlist)";
				exit;
			}
		}
	}
}
?>
